Package com.io7m.coffeepick.runtime.parser.spi

# Class FormatVersion.Builder

java.lang.Object
com.io7m.coffeepick.runtime.parser.spi.FormatVersion.Builder

Enclosing class:
  FormatVersion

    public static final class FormatVersion.Builder
    extends java.lang.Object

Builds instances of type `FormatVersion`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `FormatVersion` | `build()` | Builds a new `FormatVersion`.
  `FormatVersion.Builder` | `from​(FormatVersionType instance)` | Fill a builder with attribute values from the provided `FormatVersionType` instance.
  `FormatVersion.Builder` | `setMajor​(int major)` | Initializes the value for the `major` attribute.
  `FormatVersion.Builder` | `setMinor​(int minor)` | Initializes the value for the `minor` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final FormatVersion.Builder from​(FormatVersionType instance)
    Fill a builder with attribute values from the provided `FormatVersionType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMajor

    public final FormatVersion.Builder setMajor​(int major)
    Initializes the value for the `major` attribute.
    Parameters:
      `major` - The value for major
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinor

    public final FormatVersion.Builder setMinor​(int minor)
    Initializes the value for the `minor` attribute.
    Parameters:
      `minor` - The value for minor
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public FormatVersion build()
    Builds a new `FormatVersion`.
    Returns:
      An immutable instance of FormatVersion
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing